/*-------------------------------------------------------------/

		́FGLUTǗNX
		prFGLUTgāAJłB
		gp@FCreateGLUTWindowĂяoƁAoB
				  iCGLUTViewpViewClassKvj
										
												2006/3/13 쐬
/--------------------------------------------------------------*/

#ifndef __GLUTMASTER_H__
#define __GLUTMASTER_H__

//GLUTɈˑ
#pragma comment( lib, "opengl32.lib" )
#pragma comment( lib, "glut32.lib" )
#include <gl/glut.h>
#include <vector>
#include "GLUTView.h"

//^C}[̏ԕۑp
struct TimerState
{
	int WindowID;	//ID
	int TimerInt;	//^C}[Ԋu(ms)
};

template<class Type>
class CGLUTMaster  
{
public:
	CGLUTMaster()//i̎擾AfBXvCݒj
	{
		LPSTR argvt;
		int argc=1;
		argvt=GetCommandLine();

		glutInit(&argc,&argvt);
		glutInitDisplayMode(GLUT_RGBA | GLUT_DOUBLE);
	}
	virtual ~CGLUTMaster(){}

	//쐬֐iViewClass,^Cg,,j
	int CreateGLUTWindow(CGLUTView<Type>* pViewClass,char *WindowTitle=NULL,int WindowWidth=200,int WindowHeight=200)
	{
		int WindowID;
		//TCY
		glutInitWindowSize(WindowWidth, WindowHeight);
		//glutő쐬
		if(WindowTitle==NULL)WindowID = glutCreateWindow("GLUT");
		else WindowID = glutCreateWindow(WindowTitle);

		//ViewClassXgɓo^
		m_pViewClassList.resize(WindowID+1,NULL);
		m_pViewClassList[WindowID] = pViewClass;

		pViewClass->SetDocument(&m_Document);
		//eR[obN֐GLUTɋB
		//SẴNXĂ΂
		glutDisplayFunc(Display);
		glutMouseFunc(Mouse);
		glutMotionFunc(Motion);
		glutReshapeFunc(Reshape);
		glutKeyboardFunc(Keyboard);
		glutSpecialFunc(SpecialKey);

		return WindowID;
	}

	void MainLoop(){glutMainLoop();}

	//fBXvCi\jR[obN
	static void Display()
	{
		//ĂяoꂽIDViewClass
		int Call_ID=glutGetWindow();
		//View̃\bhĂяo
		m_pViewClassList[Call_ID]->OnDraw();
	}

	//TCYύX
	static void Reshape(int width, int height)
	{
		int Call_ID=glutGetWindow();
		m_pViewClassList[Call_ID]->OnReshape(width,height);
	}

	//L[{[h
	static void Keyboard(unsigned char key, int x, int y)
	{
		m_KeyState.key   = key;
		m_KeyState.SpKey = -1;
		m_KeyState.x=x;
		m_KeyState.y=y;

		int Call_ID=glutGetWindow();
		m_pViewClassList[Call_ID]->OnKeyEvent(m_KeyState);
	}

	//L[iF1`12,j
	static void SpecialKey(int key, int x, int y)
	{
		m_KeyState.key   = -1;
		m_KeyState.SpKey = key;
		m_KeyState.x=x;
		m_KeyState.y=y;

		int Call_ID=glutGetWindow();
		m_pViewClassList[Call_ID]->OnKeyEvent(m_KeyState);
	}

	//}EX̃{^
	static void Mouse(int button, int state, int x, int y)
	{
		m_Mouse.button	= button;
		m_Mouse.state	= state;
		m_Mouse.x = x;
		m_Mouse.y = y;

		int Call_ID=glutGetWindow();
		m_pViewClassList[Call_ID]->OnMouseEvent(m_Mouse);
	}

	//}EXړ
	static void Motion(int x, int y)
	{
		m_Mouse.x = x;
		m_Mouse.y = y;

		int Call_ID=glutGetWindow();
		m_pViewClassList[Call_ID]->OnMouseEvent(m_Mouse);
	}

	//AChigpj
	static void Idle(){}

	//^C}[
	static void Timer(int ID)
	{
		glutSetWindow(m_TimerList[ID].WindowID);

		m_pViewClassList[m_TimerList[ID].WindowID]->OnTimer(ID);
		m_TimerList[ID].WindowID = -1;
	}

	//IɌJԂ^C}[
	static void AutoRepeatTimer(int ID)
	{
		glutSetWindow(m_TimerList[ID].WindowID);
		m_pViewClassList[m_TimerList[ID].WindowID]->OnTimer(ID);
		glutTimerFunc(m_TimerList[ID].TimerInt,AutoRepeatTimer,ID);
	}

	//^C}[쐬iĂяo(ms),ID,JԂtO(true=JԂ)j
	void SetTimer(int TimerInt,int WindowID,bool IsRepeat=false)
	{
		TimerState NewTimer;

		NewTimer.TimerInt = TimerInt;
		NewTimer.WindowID = WindowID;

		int TID;

		for(TID=0;TID<m_TimerList.size();TID++)
		{
			if(m_TimerList[TID].WindowID==-1)
			{
				m_TimerList[TID]=NewTimer;
				break;
			}
		}
		if(TID == m_TimerList.size())
			m_TimerList.push_back(NewTimer);

		if(IsRepeat)
			glutTimerFunc(NewTimer.TimerInt,AutoRepeatTimer,TID);
		else
			glutTimerFunc(NewTimer.TimerInt,Timer,TID);
	}
	
	Type* GetDoc(){return &m_Document;}

private:
	static std::vector<CGLUTView<Type>*> m_pViewClassList;	//ViewClassXg
	static Type m_Document;		//hLg
	static MouseState m_Mouse;	//}EX̏
	static KeyState   m_KeyState;//L[̏
	static std::vector<TimerState> m_TimerList;			//쒆^C}[Xg
};

//ef[^̎̂`
template<class Type>
Type CGLUTMaster<Type>::m_Document;

template<class Type>
MouseState CGLUTMaster<Type>::m_Mouse;

template<class Type>
std::vector<CGLUTView<Type>*> CGLUTMaster<Type>::m_pViewClassList;

template<class Type>
KeyState   CGLUTMaster<Type>::m_KeyState;

template<class Type>
std::vector<TimerState> CGLUTMaster<Type>::m_TimerList;

#endif // __GLUTMASTER_H__
